<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.soyatec.generation.acceleo.template.lib.common
import org.soyatec.generation.acceleo.template.lib.attributeScript
import org.soyatec.generation.acceleo.template.lib.methodScript
import org.soyatec.generation.acceleo.template.services.UmlServices
import org.soyatec.generation.acceleo.template.services.UmlAssociationServices

%>

<%script type="Enumeration" name="fullFilePath"%>
<%if (!hasStereotype("NoGenCode") 
		&& (!package.hasStereotype("NoGenCode"))){%>
<%packagePath("/")%>/<%name%>.java
<%}%>

<%script type="uml.Enumeration" name="enumJava" file="<%fullFilePath%>"%>
<%if (eContainer.eClass.name != "Model"){%>
<%if (packagePath(".") == null || packagePath(".").length() == 0){%>
<%--Display nothing when package name is null --%>
<%}else{%>
package <%packagePath(".")%>;
<%}%>
<%}%>
<%-- Generate enumeration comment  ------------------------------------------%>
/**
 * Description of the enumeration <%name%>.
 <%if (ownedComment != null){%>
 <%for (ownedComment){%>
 * <%body%>
 <%}%>
 <%}else{%><%}%>
 *
 */
<%-- Enumeration declaration ------------------------------------------------%>
public enum <%name%> {
     
     <%if ( ownedLiteral != null) {%>
     <%ownedLiteral.name.sep(", ")%>;
     <%}else{%>;<%}%>

<%-- Generate attributes -----------------------------------------------------%>
	 <%for (ownedAttribute){%><%if (!hasStereotype("NoGenCode")){%>
     <%if (ownedComment != null ){%>
     /**
      *  Description of the property <%name%>.
      <%if (ownedComment != null){%>
      <%for (ownedComment){%>
      * <%body%>
      <%}%>
      <%}else{%><%}%>
      *
      */
	 <%}%>
     <%genVisibility%><%genToJavaType%><%name%>;
	 <%}%><%}%>
  
<%--Generate operations------------------------------------------------------%>
     <%for (ownedOperation){%>
	 <%if (!hasStereotype("NoGenCode") && hasStereotype("Create")){%>
<%--** Generate methods constructor doc ------------------------------------%>
	/**
     * Description of the constructor <%name%><%genComment%>.
	 *
	 <%for (ownedParameter.select("direction != 'return'")){%>
	 * @param <%name%><%genComment%>.
		<%}%>
	 <%for (clientDependency.filterExceptionDependency){%>
 	 * @throws <%target.name%><%genComment%>.
	 <%}%>
 	 */
<%-- Generate method constructor --------------------------------------------%>
	 <%genModifier%><%parent.name%>(<%genMethodParam%>)<%genException%> {
	 <%genMethodContent%>
	 }
	 <%}%>
	 <%}%>
<%-- Generate getters and setters -------------------------------------------%>
	 <%for (getAllProperties()){%><%genAttributeGetterSetter%><%}%>
<%-- Generate methods -------------------------------------------------------%>
	 <%for (ownedOperation){%>
	 <%if (!hasStereotype("NoGenCode") && !hasStereotype("Create")){%>

<%--** Generate methods doc -------------------------------------------------%>
	 /**
   	  * Description of the method <%name%><%genComment%>.
 	  *
	  <%for (ownedParameter.select("direction != 'return'")){%>
      * @param <%name%><%genComment%>
 	  <%}%>
	  <%for (ownedParameter.select("direction == 'return'")){%>
      * @return <%name%><%genComment%>
	  <%}%>
	  <%for (clientDependency.filterExceptionDependency){%>
      * @throws <%target.name%><%genComment%>.
	  <%}%>
      */
  	  <%if (isAbstract){%>
<%--**** Generate astract method (without body)------------------------------%>
<%genModifier%><%genToJavaType%><%name%>(<%genMethodParam%>)<%genException%>;
	  <%}else{%>
<%--**** Generate no astract method (with body)------------------------------%>
<%genModifier%><%genToJavaType%><%name%>(<%genMethodParam%>)<%genException%> {
	  <%genMethodContent%>
	  }
	  <%}%><%}%><%}%>
}
